{
  description = "Koishi's NixOS flake.";

  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixos-unstable";
    flake-utils.url = "github:numtide/flake-utils";
    flake-parts.url = "github:hercules-ci/flake-parts";
    flake-parts.inputs.nixpkgs-lib.follows = "nixpkgs";
    treefmt-nix.url = "github:numtide/treefmt-nix";
    treefmt-nix.inputs.nixpkgs.follows = "nixpkgs";
    impermanence.url = "github:nix-community/impermanence/master";
    home-manager.url = "github:nix-community/home-manager";
    home-manager.inputs.nixpkgs.follows = "nixpkgs";
    plasma-manager.url = "github:pjones/plasma-manager";
    plasma-manager.inputs.nixpkgs.follows = "nixpkgs";
    plasma-manager.inputs.home-manager.follows = "home-manager";
    catppuccin.url = "github:catppuccin/nix";
    lanzaboote.url = "github:nix-community/lanzaboote/v0.4.1";
    lanzaboote.inputs.nixpkgs.follows = "nixpkgs";

    # steamdeck
    jovian.url = "github:Jovian-Experiments/Jovian-NixOS";
  };

  outputs = inputs@{self, flake-parts, treefmt-nix,...}:
  flake-parts.lib.mkFlake
  { inherit inputs; } {
    systems = [
      "x86_64-linux"
    ];

    perSystem.treefmt = {
      programs.nixfmt.enable = true;
    };
    imports = [
      ./spec
      treefmt-nix.flakeModule
    ];
  };
}
